const dbSAPPS = require('../../helpers/db');
require('dotenv').config();
const { Op } = require('sequelize');

module.exports = {
    create,
    getAll,
    option,
    count,
    update,
    delete: _delete
};

/**
 * Format an array of drugGroups by appending a modifier field to each company.
 * The modifier field is the full name of the user who last modified the company.
 * @param {Object[]} drugGroups - The array of drugGroups to format.
 * @returns {Promise<Object[]>} - The formatted array of drugGroups.
 */
const formatWithModifier = async (drugGroups) => {
    return Promise.all(
        drugGroups.map(async (drugGroup) => {
            const modifier = await dbSAPPS.User.findOne({
                where: {
                    id: drugGroup.modified_by
                },
                attributes: ['full_name']
            });

            return {
                ...drugGroup,
                modifier: modifier?.full_name
            };
        })
    );
};

/**
 * Retrieves all drugGroups with their parent drugGroup title.
 * @param {Object} params - The query parameters.
 * @param {number[]} params.drugGroupsId - The ids of the drugGroups to retrieve.
 * @returns {Promise<Object>} - The response object with the drugGroups and success status.
 */
async function getAll(params) {
    try {
        // filter
        const filterConditions = {};

        let drugGroups = []
        drugGroups = await dbSAPPS.DrugGroup.findAll({
            where: filterConditions,
            order: [['modified', 'DESC']],
        });

        drugGroups = drugGroups.map(drugGroup => {
            return {
                ...drugGroup.dataValues
            }
        });

        drugGroups = await formatWithModifier(drugGroups);

        return {
            drugGroups,
            success: true,
            message: 'Loaded successfully!'
        };
    } catch (error) {
        const errorMessage = error?.message || 'Failed to load, please try again!';
        return {
            success: false,
            message: errorMessage
        };
    }
}

/**
 * Get drugGroup items with their respective settings.
 * @param {Object} params - An object that contains parameters to filter the drugGroup items.
 * @param {boolean|string} params.is_parent - A boolean or string indicating whether the drugGroup items should be parents or not.
 * @returns {Promise<Object>} Resolves with an object that contains the drugGroup items and a success flag.
 * @example
 * const result = await option({ is_parent: true });
 * console.log(result);
 */
async function option(params) {
    try {
        // filter
        const filterConditions = {};

        let options = [];
        options = await dbSAPPS.DrugGroup.findAll({
            attributes: ['id', 'name', 'display_name'],
            where: filterConditions,
            order: [['name', 'ASC']]
        });

        return {
            options,
            success: true,
            message: 'Loaded successfully!'
        };
    } catch (error) {
        const errorMessage = error?.message || 'Failed to load, please try again!';
        return {
            success: false,
            message: errorMessage
        };
    }
}

/**
 * Count active drugGroup items
 * 
 * @returns {Promise<{
 *   count: number,
 *   success: boolean,
 *   message: string
 * }>} 
 */

async function count(params) {
    try {
        // filter
        const filterConditions = {};

        const count = await dbSAPPS.DrugGroup.count({
            where: filterConditions
        });

        return {
            count,
            success: true,
            message: 'Loaded successfully!'
        };
    } catch (error) {
        const errorMessage = error?.message || 'Failed to load, please try again!';
        return {
            success: false,
            message: errorMessage
        };
    }
}

/**
 * Creates a new drugGroup item.
 * 
 * @param {Object} params - The new drugGroup item data.
 * @param {string} params.name - The name of the drugGroup item.
 * @param {string} params.title - The title of the drugGroup item.
 * @param {number} [params.parent_id] - The ID of the parent drugGroup item.
 * @param {string} [params.url] - The URL of the drugGroup item.
 * @param {string} [params.icon] - The icon of the drugGroup item.
 * @param {string} [params.type=link] - The type of the drugGroup item (link, group, collapse, separator).
 * @param {boolean} [params.enabled=true] - Whether the drugGroup item is enabled.
 * @param {number} [params.creation=Date.now()] - The creation timestamp of the drugGroup item.
 * @param {number} [params.modified=Date.now()] - The last modification timestamp of the drugGroup item.
 * @param {number} [params.owner=1] - The ID of the user who created the drugGroup item.
 * @param {number} [params.modified_by=1] - The ID of the user who last modified the drugGroup item.
 * 
 * @returns {Promise<{success: boolean, message: string}>} Result of the drugGroup item creation process.
 */
async function create(params) {
    const transaction = await dbSAPPS.sequelize.transaction();
    try {
        // validate existing
        const existingDisplayName = await dbSAPPS.DrugGroup.findOne({
            where: { display_name: params.display_name },
            transaction
        });
        if (existingDisplayName) {
            return {
                success: false,
                message: `"${params.display_name}" is already taken.`
            };
        }

        // save
        await dbSAPPS.DrugGroup.create(params, { transaction });

        await transaction.commit();
        return {
            success: true,
            message: 'Saved successfully!'
        };
    } catch (error) {
        await transaction.rollback();
        const errorMessage = error?.message || 'Failed to save, please try again!';
        return {
            success: false,
            message: errorMessage
        };
    }
}

/**
 * Updates an existing drugGroup item.
 * 
 * @param {number} id - The ID of the drugGroup item to update.
 * @param {Object} params - The updated drugGroup item data.
 * @param {string} [params.name] - The new name of the drugGroup item.
 * @param {string} [params.title] - The new title of the drugGroup item.
 * @param {number} [params.parent_id] - The new parent ID of the drugGroup item.
 * @param {string} [params.url] - The new URL of the drugGroup item.
 * @param {string} [params.icon] - The new icon of the drugGroup item.
 * @param {string} [params.type] - The new type of the drugGroup item (link, group, collapse, separator).
 * @param {boolean} [params.enabled] - Whether the drugGroup item is enabled or not.
 * @param {number} [params.creation] - The new creation timestamp of the drugGroup item.
 * @param {number} [params.modified] - The new last modification timestamp of the drugGroup item.
 * @param {number} [params.owner] - The new ID of the user who created the drugGroup item.
 * @param {number} [params.modified_by] - The new ID of the user who last modified the drugGroup item.
 * 
 * @returns {Promise<{success: boolean, message: string}>} Result of the drugGroup item update process.
 */
async function update(id, params) {
    const transaction = await dbSAPPS.sequelize.transaction();
    try {
        // validate existing
        const drugGroup = await dbSAPPS.DrugGroup.findByPk(id);
        if (!drugGroup) return { success: false, message: 'ID not found!' };

        // validate existing
        const existingDisplayName = await dbSAPPS.DrugGroup.findOne({
            where: {
                display_name: params.display_name,
                id: {
                    [Op.ne]: id
                }
            },
            transaction
        });
        if (existingDisplayName) {
            return {
                success: false,
                message: `"${params.display_name}" is already taken.`
            };
        }

        // save
        await drugGroup.update(params, { transaction });

        await transaction.commit();
        return {
            success: true,
            message: 'Saved successfully!'
        };
    } catch (error) {
        await transaction.rollback();
        const errorMessage = error?.message || 'Failed to save, please try again!';
        return {
            success: false,
            message: errorMessage
        };
    }
}

/**
 * Delete a drugGroup
 * @param {number} id - the id of the drugGroup
 * @returns {Promise<object>} - the result of the delete
 */
async function _delete(id) {
    const transaction = await dbSAPPS.sequelize.transaction();
    try {
        // validate existing
        const drugGroup = await dbSAPPS.DrugGroup.findByPk(id);
        if (!drugGroup) return { success: false, message: 'ID not found!' };

        // delete
        await drugGroup.destroy({ transaction });

        await transaction.commit();
        return {
            success: true,
            message: 'Deleted successfully!'
        };
    } catch (error) {
        await transaction.rollback();
        const errorMessage = error?.message || 'Failed to delete, please try again!';
        return {
            success: false,
            message: errorMessage
        };
    }
}
